//
//  ExtensionDelegate.m
//  testComplications WatchKit Extension
//
//  Created by James Bamford on 14/06/2016.
//  Copyright © 2016 JB. All rights reserved.
//

#import "ExtensionDelegate.h"
#import <ClockKit/ClockKit.h>

#define DbgLog(fmt, ...)    NSLog((@"%s:%d - " fmt), __PRETTY_FUNCTION__, __LINE__, ##__VA_ARGS__)

@interface ExtensionDelegate()
@property (nonatomic, strong, readwrite) NSDictionary *lastReceivedUserInfo;
@end

@implementation ExtensionDelegate

- (instancetype)init
{
  self = [super init];
  
  [self activateWatchConnectivitySession];
  
  return self;
}

- (void)applicationDidFinishLaunching {
    // Perform any final initialization of your application.
}

- (void)applicationDidBecomeActive {
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillResignActive {
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, etc.
}

- (void)activateWatchConnectivitySession
{
  WCSession* session = [WCSession defaultSession];
  
  session.delegate = self;
  [session activateSession];
  
  DbgLog(@"session=(%p) %@; session.reachable=%d", session, session, session.reachable);
  
  //WKExtension *extension = [WKExtension sharedExtension];
  //assert(extension.delegate == self); // cannot assert this yet as we're in init now self hasn't finished being created so cannot be setup as any delegate for the app etc
}

- (void)session:(WCSession *)session didReceiveUserInfo:(NSDictionary<NSString *, id> *)userInfo
{
  DbgLog(@"");
  
  WKExtension *extension = [WKExtension sharedExtension];
  DbgLog(@"self=%p; wkExtension=%p; userInfo=%@", self, extension, userInfo);
  
  self.lastReceivedUserInfo = userInfo;
  
  CLKComplicationServer *complicationServer = [CLKComplicationServer sharedInstance];
  for (CLKComplication *complication in complicationServer.activeComplications)
  {
    DbgLog(@"complication.family=%d in activeComplications - calling reloadTimelineForComplication", complication.family);
    [complicationServer reloadTimelineForComplication:complication];
  }
}

@end
